



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>学会WCF之试错法——安全配置报错分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">学会WCF之试错法——安全配置报错分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 03:57:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>服务端配置</strong></p>
<div>
<pre class="prettyprint linenums">&lt;system.serviceModel&gt;<br />
     &lt;bindings&gt;<br />
      &lt;wsHttpBinding&gt;<br />
        &lt;binding name ="WsHttpBinding_IService" maxReceivedMessageSize="370000" receiveTimeout="00:10:01" maxBufferPoolSize="100"&gt;<br />
          &lt;readerQuotas maxStringContentLength="240000"/&gt;<br />
          &lt;security mode="Transport"&gt;<br />
            &lt;transport clientCredentialType="Windows"&gt;&lt;/transport&gt;<br />
          &lt;/security&gt;<br />
        &lt;/binding&gt;<br />
      &lt;/wsHttpBinding&gt;<br />
    &lt;/bindings&gt;<br />
    &lt;services&gt;<br />
      &lt;service name="WCF_Find_Error_Lib.Service" behaviorConfiguration="beh"&gt;<br />
        &lt;endpoint address=""<br />
                  binding="wsHttpBinding"<br />
                  contract="WCF_Find_Error_Lib.IService"<br />
                  bindingConfiguration="WsHttpBinding_IService"&gt;<br />
        &lt;/endpoint&gt;<br />
        &lt;host&gt;<br />
          &lt;baseAddresses&gt;<br />
            &lt;add baseAddress="http://localhost/S" /&gt;<br />
          &lt;/baseAddresses&gt;<br />
        &lt;/host&gt;<br />
      &lt;/service&gt;<br />
    &lt;/services&gt;<br />
    &lt;behaviors&gt;<br />
      &lt;serviceBehaviors&gt;<br />
        &lt;behavior name="beh"&gt;<br />
          &lt;serviceThrottling maxConcurrentCalls="1"/&gt;<br />
          &lt;serviceMetadata httpGetEnabled="True" httpsGetEnabled="True" httpGetUrl="http://localhost/S"/&gt;<br />
          &lt;serviceDebug includeExceptionDetailInFaults="True" /&gt;<br />
        &lt;/behavior&gt;<br />
      &lt;/serviceBehaviors&gt;<br />
    &lt;/behaviors&gt;<br />
  &lt;/system.serviceModel&gt;</pre>
</div>
<p><strong>服务契约</strong></p>
<div>
<pre class="prettyprint linenums">[ServiceContract]<br />
    public interface IService<br />
    {<br />
        [OperationContract]<br />
        string GetData(int value);

        [OperationContract]<br />
        string GetString(string value);

        [OperationContract]<br />
        void Upload(Request request);<br />
    }

    [MessageContract]<br />
    public class Request<br />
    {<br />
        [MessageHeader(MustUnderstand = true)]<br />
        public string FileName { get; set; }

        [MessageBodyMember(Order = )]<br />
        public Stream Content {get;set;}<br />
}</pre>
</div>
<p><strong>服务</strong></p>
<div>
<pre class="prettyprint linenums">[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession, ConcurrencyMode = ConcurrencyMode.Reentrant)]<br />
    public class Service : IService<br />
    {<br />
        public string GetData(int value)<br />
        {<br />
            //Thread.Sleep(120000);<br />
            return string.Format("You entered: {0}", value);<br />
        }

        public string GetString(string value)<br />
        {<br />
            //Thread.Sleep(120000);<br />
            Thread.Sleep();<br />
            return string.Format("You entered: {0}", value);<br />
        }

        public void Upload(Request request)<br />
        {<br />
            try<br />
            {<br />
                StreamReader sr = new StreamReader(request.Content, Encoding.GetEncoding("GB2312"));<br />
                StreamWriter sw = new StreamWriter("E:\\" + request.FileName + ".txt", false, Encoding.GetEncoding("GB2312"));<br />
                while (!sr.EndOfStream)<br />
                {<br />
                    sw.WriteLine(sr.ReadLine());<br />
                    Thread.Sleep();<br />
                }<br />
                sr.Close();<br />
                sw.Close();<br />
            }<br />
            catch (Exception ex)<br />
            { }

        }<br />
　　}</pre>
</div>
<p><strong>服务寄宿</strong></p>
<div>
<pre class="prettyprint linenums">　　class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            try<br />
            {<br />
                ServiceHost host = new ServiceHost(typeof(Service));<br />
                host.Open();<br />
                Console.WriteLine("服务状态："+host.State.ToString());<br />
            }<br />
            catch (Exception ex)<br />
            {<br />
                Console.WriteLine(ex.Message);<br />
            }

            Console.WriteLine("服务启动");<br />
            Console.WriteLine("按任意键停止服务");<br />
            Console.ReadLine();<br />
        }<br />
　　}</pre>
</div>
<p><strong>客户端配置</strong></p>
<div>
<pre class="prettyprint linenums">&lt;system.serviceModel&gt;<br />
    &lt;bindings&gt;<br />
      &lt;wsHttpBinding&gt;<br />
        &lt;binding name ="WsHttpBinding_IService" maxReceivedMessageSize="370000" receiveTimeout="00:10:01" maxBufferPoolSize="100"&gt;<br />
          &lt;readerQuotas maxStringContentLength="240000"/&gt;<br />
          &lt;security mode="Transport"&gt;<br />
            &lt;transport clientCredentialType="Windows"&gt;<br />
            &lt;/transport&gt;<br />
          &lt;/security&gt;<br />
        &lt;/binding&gt;<br />
      &lt;/wsHttpBinding&gt;<br />
    &lt;/bindings&gt;<br />
    &lt;client&gt;<br />
      &lt;endpoint address="http://localhost/S" binding="wsHttpBinding"<br />
          bindingConfiguration="WsHttpBinding_IService" contract="IService"<br />
          name="WHttpBinding_IService" /&gt;<br />
    &lt;/client&gt;<br />
  &lt;/system.serviceModel&gt;</pre>
</div>
<p><strong>客户端代理</strong></p>
<div>
<pre class="prettyprint linenums">　　public class ServiceProxy<br />
    {<br />
        public string GetData(int value)<br />
        {<br />
            string ret = null;<br />
            ServiceClient client = null;<br />
            try<br />
            {<br />
                client = new ServiceClient();<br />
                ret = client.GetData(value);<br />
                client.Close();<br />
            }<br />
            catch<br />
            {<br />
                if (client != null)<br />
                {<br />
                    client.Abort();<br />
                }<br />
                throw;<br />
            }<br />
            return ret;<br />
        }

        public string GetString(string value)<br />
        {<br />
            string ret = null;<br />
            ServiceClient client = null;<br />
            try<br />
            {<br />
                client = new ServiceClient();<br />
                ret = client.GetString(value);<br />
                client.Close();<br />
            }<br />
            catch<br />
            {<br />
                if (client != null)<br />
                {<br />
                    client.Abort();<br />
                }<br />
                throw;<br />
            }<br />
            return ret;<br />
        }<br />
        public void Upload(Request request)<br />
        {<br />
            ServiceClient client = null;<br />
            try<br />
            {<br />
                client = new ServiceClient();<br />
                client.Upload(request);<br />
                client.Close();<br />
            }<br />
            catch<br />
            {<br />
                if (client != null)<br />
                {<br />
                    client.Abort();<br />
                }<br />
                throw;<br />
            }<br />
        }

    }

    [ServiceContractAttribute(ConfigurationName = "IService")]<br />
    public interface IService<br />
    {

        [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IService/GetData", ReplyAction = "http://tempuri.org/IService/GetDataResponse")]<br />
        string GetData(int value);

        [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IService/GetString", ReplyAction = "http://tempuri.org/IService/GetStringResponse")]<br />
        string GetString(string value);

        [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IService/Upload", ReplyAction = "http://tempuri.org/IService/UploadResponse")]<br />
        void Upload(Request request);<br />
    }<br />
    [MessageContract]<br />
    public class Request<br />
    {<br />
        [MessageHeader(MustUnderstand = true)]<br />
        public string FileName { get; set; }

        [MessageBodyMember(Order = )]<br />
        public Stream Content { get; set; }<br />
    }<br />
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall, ConcurrencyMode = ConcurrencyMode.Reentrant)]<br />
    public class ServiceClient : System.ServiceModel.ClientBase&lt;IService&gt;, IService<br />
    {

        public ServiceClient()<br />
        {<br />
        }

        public string GetData(int value)<br />
        {<br />
            return base.Channel.GetData(value);<br />
        }

        public string GetString(string value)<br />
        {<br />
            return base.Channel.GetString(value);<br />
        }

        public void Upload(Request request)<br />
        {<br />
            base.Channel.Upload(request);<br />
        }<br />
　　}</pre>
</div>
<p>1 <strong>Transport</strong><strong>安全模式（本机调试）</strong></p>
<p><strong>&nbsp;</strong><strong><em>客户端调用</em></strong></p>
<div>
<pre class="prettyprint linenums">using (ServiceClient client = new ServiceClient())<br />
{<br />
    StreamReader sr = new StreamReader("D:\\CSBMTEMP.txt", Encoding.Default);<br />
    string str = sr.ReadToEnd();<br />
    sr.Close();<br />
    var s = client.GetString(str);<br />
}</pre>
</div>
<p>服务端和客户端配置如上。wsHttpBinding的Message安全模式，客户端凭据默认为Windows</p>
<p>运行客户端，抛出异常：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1024858/201711/1024858-20171119125646140-720169741.png" /></p>
<p>抛出异常的原因是，Transport模式支持HTTPS，TCP，ICP，MSMQ，而这里终结点地址是http://localhost/S，没有使用HTTPS协议。将终结点地址改为https://localhost/S即可。</p>
<p><strong><em>服务端和客户端配置的安全模式不一样时</em></strong></p>
<p>服务端安全模式修改为：</p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Transport"&gt;<br />
       &lt;transport clientCredentialType="Basic"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>客户端保持不变：</p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Transport"&gt;<br />
     &lt;transport clientCredentialType="Windows"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>运行客户端，抛出异常：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1024858/201711/1024858-20171119125804140-1391239540.png" /></p>
<p><strong><em>将客户端安全配置改为Basic，与服务端相同</em></strong></p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Transport"&gt;<br />
            &lt;transport clientCredentialType="Basic"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>运行客户端，抛出异常，因为Transport模式不支持Basic这种客户端凭据。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1024858/201711/1024858-20171119125856202-899895448.png" /></p>
<p>2 <strong>Message安全模式</strong><strong>（本机调试）</strong></p>
<p><strong>&nbsp;</strong>wsHttpBinding的Message安全模式，客户端凭据默认为Windows。</p>
<p><strong><em>服务地址配置为</em></strong><strong><em>https://localhost/S</em></strong><strong><em>，服务端与客户端安全模式相同</em></strong></p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Message"&gt;<br />
     &lt;transport clientCredentialType="Windows"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>运行客户端，抛出异常</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1024858/201711/1024858-20171119130000421-1986498394.png" /></p>
<p>抛出异常的原因是，wsHttpBinding的Message安全模式不支持https协议，改为http协议则正常。</p>
<p><strong><em>但是，当服务端的客户端凭据配置与客户端不一致时，也可以正常执行，并获得正常的结果。</em></strong></p>
<p>例如，服务端配置：</p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Message"&gt;<br />
       &lt;transport clientCredentialType="Basic"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>客户端配置：</p>
<div>
<pre class="prettyprint linenums">&lt;security mode="Message"&gt;<br />
      &lt;transport clientCredentialType="Windows"&gt;&lt;/transport&gt;<br />
&lt;/security&gt;</pre>
</div>
<p>-----------------------------------------------------------------------------------------</p>
<div>
<p>转载与引用请注明出处。</p>
<p>时间仓促，水平有限，如有不当之处，欢迎指正。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mdggq.html">js特效&comma;加速度&comma;图标跳动</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k222r8.html">VAssistX使用小窍门</a>
		</li>
						<li><a href="https://www.batexi.com/a/495k4mv9.html">SpringMVC学习系列（4） 之 数据绑定-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnv3oq.html">《Java程序设计》第十周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdvko8.html">设计模式之观察者模式&lpar;Observer&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okvw559.html">hdu 4738 Caocao&amp;&num;39&semi;s Bridges（桥的最小权值&plus;去重）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okg2j59.html">SDUT2484算术表达式的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y701jq.html">There is a legend about a bird</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd7xnmq.html">cas 官方文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gml2dz9.html">struts2日常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwol0q.html">jQuery 表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokxe3q.html">Python笔记6（异常）-20160924</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mym2q.html">node中 path&period;resolve 和path&period;join的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e40ymk9.html">牛客练习赛 A题 筱玛的快乐</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy47zx9.html">配置logback</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv03wx8.html">NOIP2012题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o60kg8.html">linux按键映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv43pxq.html">HDU 2546 饭卡（0-1背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/963yo2y9.html">捷通华声TTS在Aster&plus;中的安装过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx24p108.html">安装node版本管理工具之NVM</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdpr0zxq.html">用html &plus;js&plus;css 实现页面轮播图效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpr07j9.html">c&num; 反射得到实体类的字段名称和值，DataTable转List&amp;lt&semi;T&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy10d5mq.html">springboot高并发redis细粒度加锁&lpar;key粒度加锁&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj4jlk8.html">【学习】js学习笔记：内置顶层函数eval&lpar;&rpar;的兼容用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd2w6y9.html">博客发在win10&period;me</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgk45r8.html">ThreadPoolExecutor系列&amp;lt&semi;一、ThreadPoolExecutor 机制&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8merdypq.html">【转】C语言产生随机数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8merll2q.html">如何透彻分析Java开发人员</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyr5jz9.html">【ASP&period;NET MVC 学习笔记】- 10 Controller和Action（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jym1l8.html">ELK系列~对fluentd参数的理解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
